unit MDIFrame;

interface

uses
  SysUtils, Windows, Messages, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, ComCtrls, ToolWin, Buttons, ExtCtrls;

type
  TFrameForm = class(TForm)
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    New1: TMenuItem;
    Open1: TMenuItem;
    N1: TMenuItem;
    Exit1: TMenuItem;
    Window1: TMenuItem;
    Tile1: TMenuItem;
    Cascade1: TMenuItem;
    Arrangeicons1: TMenuItem;
    OpenFileDialog: TOpenDialog;
    Cypher1: TMenuItem;
    Execute1: TMenuItem;
    Options1: TMenuItem;
    IgnoreVowels1: TMenuItem;
    Number1: TMenuItem;
    StatusBar1: TStatusBar;
    Panel1: TPanel;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    Bevel1: TBevel;
    Help1: TMenuItem;
    About1: TMenuItem;
    SpeedButton4: TSpeedButton;
    SpeedButton5: TSpeedButton;
    SpeedButton6: TSpeedButton;
    SpeedButton7: TSpeedButton;
    Keepfirstvowel1: TMenuItem;
    SkipAll1: TMenuItem;
    procedure Exit1Click(Sender: TObject);
    procedure New1Click(Sender: TObject);
    procedure Tile1Click(Sender: TObject);
    procedure Cascade1Click(Sender: TObject);
    procedure Arrangeicons1Click(Sender: TObject);
    procedure Open1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Execute1Click(Sender: TObject);
    procedure Number1Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
    procedure SpeedButton5Click(Sender: TObject);
    procedure SpeedButton6Click(Sender: TObject);
    procedure SpeedButton7Click(Sender: TObject);
    procedure Keepfirstvowel1Click(Sender: TObject);
    procedure SkipAll1Click(Sender: TObject);
  private
    { Private declarations }
  public

//    stopit : boolean;
    { Public declarations }
  end;

var
  FrameForm: TFrameForm;
  stopit : boolean;
  CypNum : integer;

implementation

uses MDIEdit;

{$R *.DFM}

procedure TFrameForm.Exit1Click(Sender: TObject);
begin
  Close;
end;

procedure TFrameForm.New1Click(Sender: TObject);
begin
  TEditForm.Create(Self);
end;

procedure TFrameForm.Tile1Click(Sender: TObject);
begin
  Tile;
end;

procedure TFrameForm.Cascade1Click(Sender: TObject);
begin
  Cascade;
end;

procedure TFrameForm.Arrangeicons1Click(Sender: TObject);
begin
  ArrangeIcons;
end;

procedure TFrameForm.Open1Click(Sender: TObject);
begin
  if OpenFileDialog.Execute then
  with TEditForm.Create(Self) do
    Open(OpenFileDialog.FileName);
end;

procedure TFrameForm.FormCreate(Sender: TObject);
begin
  CypNum := 2;
  StatusBar1.Panels[1].Text := 'Cypher:' + IntToStr(CypNum);
  StatusBar1.Panels[2].Text := 'Ready';
  StopIt := False;
end;

procedure TFrameForm.Execute1Click(Sender: TObject);
type
 TLetters = set of char;
 TVowels = set of char;
var
  mystring : string;
  x : integer;
  Letters : TLetters;
  Vowels : TVowels;
  cnt : integer;
begin
  if not assigned(ActiveMDIChild) then exit;
  With (ActiveMDIChild as TEditForm) do begin
    if Length(Editor.Text) = 0 then exit;
    Stopit := False;
    SpeedButton4.Visible := True;
    cnt := 0;
    Letters := ['A'..'Z', 'a'..'z'];
    Vowels := ['A', 'E', 'I', 'O', 'U', 'a', 'e', 'i', 'o', 'u'];

///////////////////////////////////////////////////////////////////////////////
    If SkipAll1.Checked then
///////////////////////////////////////////////////////////////////////////////
    begin
      for x := 1 to Length(Editor.Text) do
      begin
        if (Editor.Text[x] in Letters) and not (Editor.Text[x] in Vowels) then   // letters but not vowels
           if cnt < CypNum then
           begin
             mystring := mystring + Editor.Text[x];
             cnt := cnt + 1;
           end;
        if not (Editor.Text[x] in Letters) then          // non letters
        begin
          Application.ProcessMessages;
          StatusBar1.Panels[2].Text := 'Computing .. ' + IntToStr(x) + ' of ' + IntToStr(Length(Editor.Text)) + ' characters (Escape to cancel)';
          mystring := mystring + Editor.Text[x];
          cnt := 0;
          If Stopit then
          begin
             StatusBar1.Panels[2].Text := 'Halted';
             SpeedButton4.Visible := False;
             exit;
          end;
        end;
      end;
    end;

///////////////////////////////////////////////////////////////////////////////
    If KeepFirstVowel1.Checked then
///////////////////////////////////////////////////////////////////////////////
    begin
      for x := 1 to Length(Editor.Text) do
      begin
        if (Editor.Text[x] in Letters) and not (Editor.Text[x] in Vowels) then   // letters but not vowels
           if cnt < CypNum then
           begin
             mystring := mystring + Editor.Text[x];
             cnt := cnt + 1;
           end;

        if (Editor.Text[x] in Vowels) and (cnt = 0) then
           if cnt < CypNum then
           begin
             mystring := mystring + Editor.Text[x];
             cnt := cnt + 1;
           end;

        if not (Editor.Text[x] in Letters) then          // non letters
        begin
          mystring := mystring + Editor.Text[x];

          Application.ProcessMessages;
          StatusBar1.Panels[2].Text := 'Computing .. ' + IntToStr(x) + ' of ' + IntToStr(Length(Editor.Text)) + ' characters (Escape to cancel)';
          cnt := 0;
          If Stopit then
          begin
             StatusBar1.Panels[2].Text := 'Halted';
             SpeedButton4.Visible := False;
             exit;
          end;
        end;
      end;
    end;

///////////////////////////////////////////////////////////////////////////////
    If not (SkipAll1.Checked) and not (KeepFirstVowel1.Checked) then
///////////////////////////////////////////////////////////////////////////////
    begin
      for x := 1 to Length(Editor.Text) do
      begin
        if Editor.Text[x] in Letters then              // letters
           if cnt < CypNum then
           begin
             mystring := mystring + Editor.Text[x];
             cnt := cnt + 1;
           end;
        if not (Editor.Text[x] in Letters) then          // non letters
        begin
          Application.ProcessMessages;
          StatusBar1.Panels[2].Text := 'Computing .. ' + IntToStr(x) + ' of ' + IntToStr(Length(Editor.Text)) + ' characters (Escape to cancel)';
          mystring := mystring + Editor.Text[x];
          cnt := 0;
          If Stopit then
          begin
             StatusBar1.Panels[2].Text := 'Halted';
             SpeedButton4.Visible := False;
             exit;
          end;
        end;
      end;
    end;

///////////////////////////////////////////////////////////////////////////////
  end;  // with

  If not Stopit then
     StatusBar1.Panels[2].Text := 'Ready';
  with TEditForm.Create(Self) do
    editor.text := mystring;
  SpeedButton4.Visible := False;
end;

procedure TFrameForm.Number1Click(Sender: TObject);
var
  NewString: string;
  ClickedOK: Boolean;
begin
  NewString := IntToStr(CypNum);
  ClickedOK := InputQuery('Enter number of letters', 'Letters', NewString);
  if ClickedOK then                 { NewString contains new input string }
    CypNum := StrToIntDef(NewString, 2);
  StatusBar1.Panels[1].Text := 'Cypher:' +  NewString;
end;

procedure TFrameForm.About1Click(Sender: TObject);
begin
  Showmessage('Tcy version .02' + #13 + 'Copyright 1999 John Bohumil.  All rights reserved.' + #13 + 'This is program freeware!' + #13 + 'Updates http://www.winternet.com/~robin')
end;

procedure TFrameForm.SpeedButton4Click(Sender: TObject);
begin
  Stopit := True;
end;

procedure TFrameForm.SpeedButton5Click(Sender: TObject);
begin
  if not assigned(ActiveMDIChild) then exit;
  (ActiveMDIChild as TEditForm).Copy1Click(Self);
end;

procedure TFrameForm.SpeedButton6Click(Sender: TObject);
begin
  if not assigned(ActiveMDIChild) then exit;
  (ActiveMDIChild as TEditForm).Cut1Click(Self);
end;

procedure TFrameForm.SpeedButton7Click(Sender: TObject);
begin
  if not assigned(ActiveMDIChild) then exit;
  (ActiveMDIChild as TEditForm).Paste1Click(Self);
end;

procedure TFrameForm.Keepfirstvowel1Click(Sender: TObject);
begin
  Keepfirstvowel1.Checked := not Keepfirstvowel1.Checked;
  If Keepfirstvowel1.Checked then
    StatusBar1.Panels[0].Text := 'FV'
    else
    StatusBar1.Panels[0].Text := ''
end;

procedure TFrameForm.SkipAll1Click(Sender: TObject);
begin
  Skipall1.Checked := not Skipall1.Checked;
  If Skipall1.Checked then
    StatusBar1.Panels[0].Text := 'AV'
    else
    StatusBar1.Panels[0].Text := ''
end;

end.
